#include <stdio.h>
#include <limits.h>

int V, M;

int graph[302][302], matrix[302][302], Me[302][302];
 
void readInput()
{
	FILE* in = fopen("graph.in", "r");
	fscanf(in, "%d %d", &V, &M);
	for (int i = 0; i < M; i++)
    {
        int from, to, value;
		fscanf(in, "%d %d %d", &from, &to, &value);
        graph[from - 1][to - 1] = value;
        graph[to -1][from - 1] = value;
        Me[from][to] = i + 1;
        Me[to][from] = i + 1;
    }
    for(int i = 0; i < V; i ++)
    {
        for(int j = 0; j < V; j++)
        {
            fscanf(in, "%d", &matrix[i][j]);
        }
    }
    fclose(in);
}

FILE* out;

int minKey(int key[], bool mstSet[])
{
   int min = INT_MAX, min_index;
 
   for (int v = 0; v < V; v++)
     if (mstSet[v] == false && key[v] < min)
         min = key[v], min_index = v;
 
   return min_index;
}

int printMST(int parent[], int n)
{
   for (int i = 1; i < V; i++)
   {
      if(n == parent[i])
      {
            fprintf(out, "%d \n", Me[i + 1][parent[i] + 1]);
            printMST(parent, i);
      }
   }
}
 
void primMST()
{
     int parent[V];
     int key[V]; 
     bool mstSet[V]; 
 
     for (int i = 0; i < V; i++)
        key[i] = INT_MAX, mstSet[i] = false;
 
     key[0] = 0; 
     parent[0] = -1;
 
     for (int count = 0; count < V-1; count++)
     {
        int u = minKey(key, mstSet);
 		  mstSet[u] = true;
 		  for (int v = 0; v < V; v++)
        if (graph[u][v] && mstSet[v] == false && graph[u][v] <  key[v])
             parent[v]  = u, key[v] = graph[u][v];
     }
 
     printMST(parent, 0);
}
 
 
int main()
{
    out = fopen("graph.out", "w");
    readInput();
    primMST();
    fclose(out);
    return 0;
}